

puts "loading sys.V1495DPP.tcl"


variable registerlist

lappend registerlist [list NetVar.V1495DPP_UseCtrl  "-n V1495DPP_UseCtrl -t int"]

variable V1495DPP_Base 4
variable Use1495DPP 0




proc Set_V1495DPP_Options {} {puts "Set_V1495DPP_Options"
    variable Options
    variable V1495DPP_Base
    variable Use1495DPP

    load_Options

   if {![info exists Options(V1495DPP_Base)]} {set Options(V1495DPP_Base) $V1495DPP_Base}
   if {![info exists Options(Use1495DPP)]}    {set Options(Use1495DPP) 0}

   set V1495DPP_Base  $Options(V1495DPP_Base)
   set Use1495DPP  $Options(Use1495DPP)

    update_Options
}

proc V1495DPP_Configure {} {puts "V1495DPP_Configure"}

proc V1495DPP_DAQ-go {} {puts "V1495DPP_DAQ-go"
    WriteVMERegister v1495dpp#1.FT_RUN 1
    WriteVMERegister v1495dpp#1.MIS4 3
}

proc V1495DPP_DAQ-halt {} {puts "V1495DPP_DAQ-halt"
    WriteVMERegister v1495dpp#1.FT_RUN 0
    WriteVMERegister v1495dpp#1.MIS4 0
}

proc V1495DPP_DAQ-setup {} {puts "V1495DPP_DAQ-setup"; WriteVMERegister v1495dpp#1.FT_RUN 0; V1495DPP_Configure}

proc V1495DPP_DAQ-flush {} {puts "V1495DPP_DAQ-flush"}

proc V1495DPP_DAQ-reset {} {puts "V1495DPP_DAQ-reset"; WriteVMERegister v1495dpp#1.FT_RUN 0}

proc define_V1495DPP_config {} {puts "define_V1495DPP_config"
   variable Options
   variable V1495DPPPres 
   variable Use1495DPP

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1495dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {set V1495DPPPres 1; set Use1495DPP 1} else {set V1495DPPPres 0; set Use1495DPP 0}

   set Options(V1495DPPPres) $V1495DPPPres
   set Options(Use1495DPP) $Use1495DPP

   if {$maxmodule > 0} then {DefineConfig "1495 0 [format "0x%x" $Options(V1495DPP_Base)]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1495dpp#$i.DataBuffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1495dpp#$i.DataBuffer"
          error $m
      }

      DefineConfig "1495 $i [string range [first $m] 2 end]"
   }

puts "V1495DPPPres=$V1495DPPPres; Use1495DPP=$Options(Use1495DPP); V1495DPP_Base=$Options(V1495DPP_Base)"

}


proc create_V1495DPP_spectra {} {
    variable V1495DPP_Base

puts "create_V1495DPP_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1495dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

#     if {$Options(V1495DPP_Hist.Enable) == 1} {

#    so item rate available in Stat & Rate histograms

           set spectrumname v1495dpp#$i.data
           set z [catch {CreateSpectrum1D $spectrumname 100} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               set group [expr ($i - 1) + $V1495DPP_Base]
               set item 0
               map_spectrum  "$spectrumname $group $item 0 0"

           }
#     }

   }

}




