

puts "loading sys.V1724PHA.tcl"

variable registerlist

lappend registerlist [list NetVar.V1724PHA_NumSamples  "-n V1724PHA_NumSamples -t int"]
lappend registerlist [list NetVar.V1724PHA_VMERetries  "-n V1724PHA_VMERetries -t int"]
lappend registerlist [list NetVar.V1724PHA_BERREnable  "-n V1724PHA_BERREnable -t int"]
lappend registerlist [list NetVar.V1724PHA_VMEBufSize  "-n V1724PHA_VMEBufSize -t int"]

lappend registerlist [list NetVar.V1724PHA_TraceOpt    "-n V1724PHA_TraceOpt -t int"]
lappend registerlist [list NetVar.V1724PHA_Trig        "-n V1724PHA_Trig -t int"]
lappend registerlist [list NetVar.V1724PHA_DVP         "-n V1724PHA_DVP -t int"]
lappend registerlist [list NetVar.V1724PHA_Diag        "-n V1724PHA_Diag -t int"]

variable V1724PHA_Base 64

proc Set_V1724PHA_Options {} {
    variable Options
    variable V1724PHA_Base

puts "Set_V1724PHA_Options"

    load_Options

   if {![info exists Options(V1724PHA_TraceOpt)]}              {set Options(V1724PHA_TraceOpt) 0}
   if {![info exists Options(V1724PHA_Trig)]}                  {set Options(V1724PHA_Trig) 0}
   if {![info exists Options(V1724PHA_DVP)]}                   {set Options(V1724PHA_DVP) 0}
   if {![info exists Options(V1724PHA_Diag)]}                  {set Options(V1724PHA_Diag) 0}
   if {![info exists Options(V1724PHA_MaxEvtsPerBuf)]}         {set Options(V1724PHA_MaxEvtsPerBuf) 1}
   if {![info exists Options(V1724PHA_MaxBLT)]}                {set Options(V1724PHA_MaxBLT) 1}
   if {![info exists Options(V1724PHA_MemBufSize)]}            {set Options(V1724PHA_MemBufSize) 1024}
   if {![info exists Options(V1724PHA_VMEBufSize)]}            {set Options(V1724PHA_VMEBufSize) 16384}

   if {![info exists Options(V1724PHA_Hist_Diag.Enable)]}      {set Options(V1724PHA_Hist_Diag.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_Diag.channels)]}    {set Options(V1724PHA_Hist_Diag.channels) 16384}

   if {![info exists Options(V1724PHA_Hist_TraceA.Enable)]}    {set Options(V1724PHA_Hist_TraceA.Enable) 1}
   if {![info exists Options(V1724PHA_Hist_Energy.Enable)]}    {set Options(V1724PHA_Hist_Energy.Enable) 1}
   if {![info exists Options(V1724PHA_Hist_BaseLine.Enable)]}  {set Options(V1724PHA_Hist_BaseLine.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.Enable)]}     {set Options(V1724PHA_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.Enable)]}     {set Options(V1724PHA_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1724PHA_Hist_TraceA.channels)]}  {set Options(V1724PHA_Hist_TraceA.channels) 512}
   if {![info exists Options(V1724PHA_Hist_TraceA.offset)]}    {set Options(V1724PHA_Hist_TraceA.offset) 0}
   if {![info exists Options(V1724PHA_Hist_TraceA.shift)]}     {set Options(V1724PHA_Hist_TraceA.shift) 0}
   if {![info exists Options(V1724PHA_Hist_Energy.channels)]}  {set Options(V1724PHA_Hist_Energy.channels) 32768}
   if {![info exists Options(V1724PHA_Hist_Energy.offset)]}    {set Options(V1724PHA_Hist_Energy.offset) 0}
   if {![info exists Options(V1724PHA_Hist_Energy.shift)]}     {set Options(V1724PHA_Hist_Energy.shift) 0}
   if {![info exists Options(V1724PHA_Hist_BaseLine.channels)]}  {set Options(V1724PHA_Hist_BaseLine.channels) 65536}
   if {![info exists Options(V1724PHA_Hist_BaseLine.offset)]}    {set Options(V1724PHA_Hist_BaseLine.offset) 0}
   if {![info exists Options(V1724PHA_Hist_BaseLine.shift)]}     {set Options(V1724PHA_Hist_BaseLine.shift) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.channels)]}   {set Options(V1724PHA_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1724PHA_Hist_TimeH.offset)]}     {set Options(V1724PHA_Hist_TimeH.offset) 0}
   if {![info exists Options(V1724PHA_Hist_TimeH.shift)]}      {set Options(V1724PHA_Hist_TimeH.shift) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.channels)]}   {set Options(V1724PHA_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1724PHA_Hist_TimeL.offset)]}     {set Options(V1724PHA_Hist_TimeL.offset) 0}
   if {![info exists Options(V1724PHA_Hist_TimeL.shift)]}      {set Options(V1724PHA_Hist_TimeL.shift) 0}
   if {![info exists Options(V1724PHA_GroupBase)]}             {set Options(V1724PHA_GroupBase) $V1724PHA_Base}
   set V1724PHA_Base  $Options(V1724PHA_GroupBase)

    update_Options
}

proc V1724PHA_Configure {} {
    variable Options

puts "V1724PHA_Configure"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.V1724PHA_VMEBufSize]
    set Options(V1724PHA_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

    WriteNetVar NetVar.V1724PHA_Trig $Options(V1724PHA_Trig)
    WriteNetVar NetVar.V1724PHA_DVP  $Options(V1724PHA_DVP)
    WriteNetVar NetVar.V1724PHA_Diag  $Options(V1724PHA_Diag)

           switch $Options(V1724PHA_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 10; set BUFF_NUM 1024}
           }

      set z [catch {ReadVMERegisterAttr v1724pha#1.VMEStatus} m]
      if {$z==0} then {

           set z [catch {WriteVMERegister v1724pha#1.VMEControl 16} m];  #  force BERR option

           set z [catch {ReadVMERegister v1724pha#1.CustomSize} SIZE];
           if {$SIZE <= 0} {set SIZE 32}
           WriteNetVar NetVar.V1724PHA_NumSamples [expr $SIZE * 2]

           set NUM [expr (($Options(V1724PHA_MemBufSize) - 2) * 2) / $SIZE]
           if {$NUM > $Options(V1724PHA_MaxEvtsPerBuf)} {set NUM $Options(V1724PHA_MaxEvtsPerBuf)}

           set z [catch {ReadVMERegister v1724pha#1.VMEControl} BERR]  ;#  enable BERR to finish a VME block transfer
           if {$BERR < 0} {set BERR 0}
           WriteNetVar NetVar.V1724PHA_BERREnable [expr ($BERR >> 4) & 1]

puts "V1724PHA Output buffers $BUFF_NUM  @ $Options(V1724PHA_MemBufSize) 32 bit words"
puts "Waveform [expr $SIZE * 2] samples"
puts "8 channels; $NUM events/buffer"

           set osize [expr (($SIZE + 2) * $NUM) + 2]
puts "V1724PHA buffer size used $osize words out of max $Options(V1724PHA_MemBufSize)"

           if {$osize > $Options(V1724PHA_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1724PHA_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / (($osize * 8) + 4)]
           if {$BLT > $Options(V1724PHA_MaxBLT)} {set BLT $Options(V1724PHA_MaxBLT)}

puts "BLT Event Number = $BLT"
           set isize [expr (($osize * 8) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "V1724PHA_Configure $BERR $SIZE $BUFF_ORG $NUM"

           WriteVMERegisters v1724pha#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters v1724pha#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters v1724pha#*.BufferOrg $BUFF_ORG
           WriteVMERegisters v1724pha#\[?,??\].EvtsPerBuf $NUM
           WriteVMERegisters v1724pha#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "V1724PHA_Configure finished"

}

proc V1724PHA_DAQ-go {} {

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1724pha#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1724pha#$i.AcqControl [expr ($m & 0xfb) + 4]}

   }
}

proc V1724PHA_DAQ-halt {} {

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1724pha#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1724pha#$i.AcqControl [expr ($m & 0xfb)]}

   }
}

proc V1724PHA_DAQ-setup {} {

     V1724PHA_Configure
}

proc V1724PHA_DAQ-flush {} {}

proc V1724PHA_DAQ-reset {} {}

proc define_V1724PHA_config {} {
    variable Options
    variable V1724PHA_Base

puts "define_V1724PHA_config"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17241 0 [format "0x%x" $V1724PHA_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1724pha#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1724pha#$i.Output_Buffer"
          error $m
      }

      DefineConfig "17241 $i [string range [first $m] 2 end]"
   }
}

proc create_V1724PHA_spectra {} {
    variable V1724PHA_Base
    variable Options 

puts "create_V1724PHA_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1724pha#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1724PHA_Hist_Diag.Enable) == 1} {

#    histograms for diagnostics output

           set spectrumname v1724pha#$i.Diag
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Diag.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               map_spectrum  "$spectrumname 0 $i 0 0"
           }
     }

     if {$Options(V1724PHA_Hist_Energy.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the computed energy

           set spectrumname v1724pha#$i.E[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_Energy.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724PHA_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_Energy.offset) $Options(V1724PHA_Hist_Energy.shift)"

           }
        }
     }

     if {$Options(V1724PHA_Hist_BaseLine.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the base line

           set spectrumname v1724pha#$i.B[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_BaseLine.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (1 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724PHA_Base]
                   set item 1
               }
               map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_BaseLine.offset) $Options(V1724PHA_Hist_BaseLine.shift)"

           }
        }
     }


     if {$Options(V1724PHA_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname v1724pha#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724PHA_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_TimeH.offset) $Options(V1724PHA_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1724PHA_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname v1724pha#$i.TL[set j]
           set-footer "Creating $spectrumname"
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724PHA_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724PHA_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724PHA_Hist_TimeL.offset) $Options(V1724PHA_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(V1724PHA_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the data trace A

           set spectrumname v1724pha#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1724PHA_Hist_TraceA.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * 8) + $j + 256  + $V1724PHA_Base] 
              map_spectrum  "$spectrumname $group 0 $Options(V1724PHA_Hist_TraceA.offset) $Options(V1724PHA_Hist_TraceA.shift)"
           }
        }
     }
   }
}

