

puts "loading sys.V1751DPP.tcl"

variable registerlist

lappend registerlist [list NetVar.V1751DPP_NumSamples  "-n V1751DPP_NumSamples -t int"]
lappend registerlist [list NetVar.V1751DPP_VMERetries  "-n V1751DPP_VMERetries -t int"]
lappend registerlist [list NetVar.V1751DPP_BERREnable  "-n V1751DPP_BERREnable -t int"]
lappend registerlist [list NetVar.V1751DPP_VMEBufSize  "-n V1751DPP_VMEBufSize -t int"]

lappend registerlist [list NetVar.V1751DPP_TraceOpt    "-n V1751DPP_TraceOpt -t int"]
lappend registerlist [list NetVar.V1751DPP_Trig        "-n V1751DPP_Trig -t int"]
lappend registerlist [list NetVar.V1751DPP_DVP         "-n V1751DPP_DVP -t int"]
lappend registerlist [list NetVar.V1751DPP_Diag        "-n V1751DPP_Diag -t int"]

variable V1751DPP_Base 64

proc Set_V1751DPP_Options {} {
    variable Options
    variable V1751DPP_Base

puts "Set_V1751DPP_Options"

    load_Options

   if {![info exists Options(V1751DPP_TraceOpt)]}              {set Options(V1751DPP_TraceOpt) 0}
   if {![info exists Options(V1751DPP_Trig)]}                  {set Options(V1751DPP_Trig) 0}
   if {![info exists Options(V1751DPP_DVP)]}                   {set Options(V1751DPP_DVP) 0}
   if {![info exists Options(V1751DPP_Diag)]}                  {set Options(V1751DPP_Diag) 0}
   if {![info exists Options(V1751DPP_MaxEvtsPerBuf)]}         {set Options(V1751DPP_MaxEvtsPerBuf) 16}
   if {![info exists Options(V1751DPP_MaxBLT)]}                {set Options(V1751DPP_MaxBLT) 1}
   if {![info exists Options(V1751DPP_MemBufSize)]}            {set Options(V1751DPP_MemBufSize) 18000}
   if {![info exists Options(V1751DPP_VMEBufSize)]}            {set Options(V1751DPP_VMEBufSize) 16384}

   if {![info exists Options(V1751DPP_Hist_TraceA.Enable)]}    {set Options(V1751DPP_Hist_TraceA.Enable) 1}
   if {![info exists Options(V1751DPP_Hist_BaseLine.Enable)]}  {set Options(V1751DPP_Hist_BaseLine.Enable) 0}
   if {![info exists Options(V1751DPP_Hist_QLong.Enable)]}     {set Options(V1751DPP_Hist_QLong.Enable) 1}
   if {![info exists Options(V1751DPP_Hist_QShort.Enable)]}    {set Options(V1751DPP_Hist_QShort.Enable) 0}
   if {![info exists Options(V1751DPP_Hist_TimeH.Enable)]}     {set Options(V1751DPP_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1751DPP_Hist_TimeL.Enable)]}     {set Options(V1751DPP_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1751DPP_Hist_TraceA.channels)]}  {set Options(V1751DPP_Hist_TraceA.channels) 512}
   if {![info exists Options(V1751DPP_Hist_TraceA.offset)]}    {set Options(V1751DPP_Hist_TraceA.offset) 0}
   if {![info exists Options(V1751DPP_Hist_TraceA.shift)]}     {set Options(V1751DPP_Hist_TraceA.shift) 0}
   if {![info exists Options(V1751DPP_Hist_BaseLine.channels)]}  {set Options(V1751DPP_Hist_BaseLine.channels) 65536}
   if {![info exists Options(V1751DPP_Hist_BaseLine.offset)]}    {set Options(V1751DPP_Hist_BaseLine.offset) 0}
   if {![info exists Options(V1751DPP_Hist_BaseLine.shift)]}     {set Options(V1751DPP_Hist_BaseLine.shift) 0}
   if {![info exists Options(V1751DPP_Hist_TimeH.channels)]}   {set Options(V1751DPP_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1751DPP_Hist_TimeH.offset)]}     {set Options(V1751DPP_Hist_TimeH.offset) 0}
   if {![info exists Options(V1751DPP_Hist_TimeH.shift)]}      {set Options(V1751DPP_Hist_TimeH.shift) 0}
   if {![info exists Options(V1751DPP_Hist_TimeL.channels)]}   {set Options(V1751DPP_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1751DPP_Hist_TimeL.offset)]}     {set Options(V1751DPP_Hist_TimeL.offset) 0}
   if {![info exists Options(V1751DPP_Hist_TimeL.shift)]}      {set Options(V1751DPP_Hist_TimeL.shift) 0}
   if {![info exists Options(V1751DPP_Hist_QLong.channels)]}   {set Options(V1751DPP_Hist_QLong.channels) 65536}
   if {![info exists Options(V1751DPP_Hist_QLong.offset)]}     {set Options(V1751DPP_Hist_QLong.offset) 0}
   if {![info exists Options(V1751DPP_Hist_QLong.shift)]}      {set Options(V1751DPP_Hist_QLong.shift) 0}
   if {![info exists Options(V1751DPP_Hist_QShort.channels)]}   {set Options(V1751DPP_Hist_QShort.channels) 65536}
   if {![info exists Options(V1751DPP_Hist_QShort.offset)]}     {set Options(V1751DPP_Hist_QShort.offset) 0}
   if {![info exists Options(V1751DPP_Hist_QShort.shift)]}      {set Options(V1751DPP_Hist_QShort.shift) 0}
   if {![info exists Options(V1751DPP_GroupBase)]}             {set Options(V1751DPP_GroupBase) $V1751DPP_Base}
   set V1751DPP_Base  $Options(V1751DPP_GroupBase)

    update_Options
}

proc V1751DPP_Configure {} {
    variable Options

puts "V1751DPP_Configure"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.V1751DPP_VMEBufSize]
    if {$VME_BUFFER_SIZE == 0} {set VME_BUFFER_SIZE 2097152}
    set Options(V1751DPP_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

    WriteNetVar NetVar.V1751DPP_Trig $Options(V1751DPP_Trig)
    WriteNetVar NetVar.V1751DPP_DVP  $Options(V1751DPP_DVP)
    WriteNetVar NetVar.V1751DPP_Diag  $Options(V1751DPP_Diag)

#  Options(V1751DPP_MemBufSize)  memory size / channel  in 32 bit words

           switch $Options(V1751DPP_MemBufSize) {
             144000  {set BUFF_ORG 2; set BUFF_NUM 4}
              72000  {set BUFF_ORG 3; set BUFF_NUM 8}
              36000  {set BUFF_ORG 4; set BUFF_NUM 16}
              18000  {set BUFF_ORG 5; set BUFF_NUM 32}
               9000  {set BUFF_ORG 6; set BUFF_NUM 64}
               4500  {set BUFF_ORG 7; set BUFF_NUM 128}
               2250  {set BUFF_ORG 8; set BUFF_NUM 256}
               1125  {set BUFF_ORG 9; set BUFF_NUM 512}
                560  {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 5; set BUFF_NUM 32}
           }

      set Buf_Size [expr $Options(V1751DPP_MemBufSize) / $BUFF_NUM]  ;# buffer in 32 bit words

      set z [catch {ReadVMERegisterAttr v1751dpp#1.VMEStatus} m]
      if {$z==0} then {

           WriteVMERegister v1751dpp#1.VMEControl 16   ;# force BERR option

           set SIZE [ReadVMERegister v1751dpp#1.CustomSize]
           if {$SIZE == 0} {set SIZE [expr 256/12]}
           WriteNetVar NetVar.V1751DPP_NumSamples [expr $SIZE * 12]

           set WORDS [expr ($SIZE * 12) / 3]   ;# convert to 32 bit words

           set NUM [expr $Options(V1751DPP_MemBufSize) / (8+$WORDS)]  ;# events per buffer
           if {$NUM > $Options(V1751DPP_MaxEvtsPerBuf)} {set NUM $Options(V1751DPP_MaxEvtsPerBuf)}

           set BERR [ReadVMERegister v1751dpp#1.VMEControl]  ;#  enable BERR to finish a VME block transfer
           WriteNetVar NetVar.V1751DPP_BERREnable [expr ($BERR >> 4) & 1]

puts "V1751DPP Output buffers $BUFF_NUM  @ $Buf_Size 32 bit words per channel"
puts "Waveform [expr $SIZE * 12] samples"
puts "8 channels; $NUM events/buffer"

           set osize [expr (($WORDS + 8) * $NUM) + 2]
puts "V1751DPP buffer size used $osize words out of max $Options(V1751DPP_MemBufSize)"

           if {$osize > $Options(V1751DPP_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1751DPP_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / (($osize * 8) + 4)]
           if {$BLT > $Options(V1751DPP_MaxBLT)} {set BLT $Options(V1751DPP_MaxBLT)}
puts "V1751DPP BLT= $BLT"

           set isize [expr (($osize * 8) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "V1751DPP_Configure $BERR $SIZE $WORDS $BUFF_ORG $NUM"

           WriteVMERegisters v1751dpp#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters v1751dpp#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters v1751dpp#*.BufferOrg $BUFF_ORG
           WriteVMERegisters v1751dpp#*.EvtsPerBuf $NUM
           WriteVMERegisters v1751dpp#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "V1751DPP_Configure finished"

}

proc V1751DPP_DAQ-go {} {

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1751dpp#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1751dpp#$i.AcqControl [expr ($m & 0xfb) + 4]}

   }
}

proc V1751DPP_DAQ-halt {} {

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1751dpp#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1751dpp#$i.AcqControl [expr ($m & 0xfb)]}

   }
}

proc V1751DPP_DAQ-setup {} {
    variable Options

     V1751DPP_Configure
}

proc V1751DPP_DAQ-flush {} {}

proc V1751DPP_DAQ-reset {} {}

proc define_V1751DPP_config {} {
    variable Options
    variable V1751DPP_Base

#   set maxmodule [inform vmecontrol inquire V1751DPPcount]
#   if {[string length $maxmodule] > 2} {set maxmodule 0}

puts "define_V1751DPP_config"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17512 0 [format "0x%x" $V1751DPP_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1751dpp#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1751dpp#$i.Output_Buffer"
          error $m
      }

      DefineConfig "17512 $i [string range [first $m] 2 end]"
   }
}

proc create_V1751DPP_spectra {} {
    variable V1751DPP_Base
    variable Options 

puts "create_V1751DPP_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751dpp#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1751DPP_Hist_QLong.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the computed charge

           set spectrumname v1751dpp#$i.QL[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_QLong.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751DPP_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1751DPP_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751DPP_Hist_QLong.offset) $Options(V1751DPP_Hist_QLong.shift)"

           }
        }
     }

     if {$Options(V1751DPP_Hist_QShort.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the computer charge

           set spectrumname v1751dpp#$i.QS[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_QShort.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751DPP_Base]
                   set item [expr $j + (1 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1751DPP_Base]
                   set item 1
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751DPP_Hist_QShort.offset) $Options(V1751DPP_Hist_QShort.shift)"

           }
        }
     }

     if {$Options(V1751DPP_Hist_BaseLine.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the base line

           set spectrumname v1751dpp#$i.B[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_BaseLine.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751DPP_Base]
                   set item [expr $j + (4 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1751DPP_Base]
                   set item 4
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751DPP_Hist_BaseLine.offset) $Options(V1751DPP_Hist_BaseLine.shift)"

           }
        }
     }

     if {$Options(V1751DPP_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname v1751dpp#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751DPP_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1751DPP_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1751DPP_Hist_TimeH.offset) $Options(V1751DPP_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1751DPP_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname v1751dpp#$i.TL[set j]
           set-footer "Creating $spectrumname"
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751DPP_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1751DPP_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1751DPP_Hist_TimeL.offset) $Options(V1751DPP_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(V1751DPP_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the data trace A

           set spectrumname v1751dpp#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751DPP_Hist_TraceA.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * 8) + $j + 256  + $V1751DPP_Base] 
              map_spectrum  "$spectrumname $group 0 $Options(V1751DPP_Hist_TraceA.offset) $Options(V1751DPP_Hist_TraceA.shift)"
           }
        }
     }

   }
}

